*+
*+
*+    Source Module => PASS.PRG
*+
*+    Functions: Static Procedure GetPassword()
*+
*+    Reformatted by Click! 1.11 on Sep-29-1997 at 11:31 pm
*+
*+

/*
Jorge Fuertes <daemon@arsys.es> scritto nell'articolo
<34281D0C.5ACEAFE1@arsys.es>...
> Richard J Bragg wrote:
> 
> > In article <01bcbe6b$cb35a580$53ed3cc7@dguay>, dennis guay
> > <dguay@sun.pris.bc.ca> writes
> > >hello fellow clipperheads!
> > >
> > >could someone please help me out?
> > >
> > >im having problems debugging my routine for password security for a
> > small
> > >application. i want a password to be entered and masked by asterisks.
> > could
> > >you take a look at mine and help me figure it out for me. ive
> > included the
> > >code as a file attachement.
> > >
> > >thanks in advance. p.s. this code originally came from BRAD HUDSON
> > via CDAT
> > >archives.
> > >
> 
> You can also work fine with CA-Tools. A magic function called
> GetSecret() uses "*" to hide it.
> 
> Bye.
> 
> 

Try this one (I love pre-processor commands)
*/

/*
In header file (CH)
--------------------
*/

#command @< row >, < col > get < var > ;
                        [<clausole,...>]                         ;
                        PASSWORD                                 ;
                        [<altreClausole,...>]                    ;
                                                                 ;
      => @ <row>, <col> GET <var>                                ;
                        [<clausole>]                             ;
                        SEND reader := {|oGet|                   ;
                                        GetPassword(oGet) }      ;
                        [<altreClausole>]

/*
The source :
--------------------
*/

*+
*+
*+    Static Procedure GetPassword()
*+
*+
*+
static procedure GetPassword( oGet )

local nTasto
local nCar
local cTasto

if ( GetPreValidate( oGet ) )
   oGet:SetFocus()
   oGet:cargo := ""
   do while ( oGet:exitState == GE_NOEXIT )
      if ( oGet:typeOut )
         oGet:exitState := GE_ENTER
      endif
      do while ( oGet:exitState == GE_NOEXIT )
         nTasto := inkey( 0 )
         IF nTasto >= 32 .and. nTasto <= 255
            oGet:cargo += chr( nTasto )
            GetApplyKey( oGet, asc( "*" ) )
         elseif nTasto == K_BS
            oGet:cargo := substr( oGet:cargo, 1, ;
                                  len( oGet:cargo ) - 1 )
            GetapplyKey( oGet, nTasto )
         elseif nTasto == K_ENTER
            GetApplyKey( oGet, nTasto )
         endif
      enddo
      if ( !GetPostValidate( oGet ) )
         oGet:exitState := GE_NOEXIT
      endif
   enddo
   oGet:KillFocus()
endif
IF oGet:exitState != GE_ESCAPE
   oGet:varPut( oGet:cargo )
endif

return

/*
and finally the call :
----------------------
*/

@ 11, 44 get cVar PASSWORD picture "XXXXXXXX" color "W+/R"       

/*
Enjoy.

dbamster @usa.net
*/

*+ EOF: PASS.PRG
